#include "card.h"
#include <stdlib.h>
#include "line.h"
using namespace std;

void card::RefreshBitmap(){
//system("/home/ppsadm/pps01/src/videoserv/ppsclient.pl > /home/pps02/Images/grabbed_image.pnm");
  bmp.read("testimage.pnm");
  //  bmp.read("~/Images/grabbed_image.pnm");
}

int card::getValue(void)
{
  return 5;
}

bool card::table(point2d p, int redthreshold){
  if( p.X() >= 0 && p.X() < bmp.getHeigth() &&
      p.Y() >= 0 && p.Y() < bmp.getWidth()    ) {
    if( bmp.map[p.X()][p.Y()].r >= redthreshold )
      return false;
    else
      return true;
  }
  else
    return true;
}


point2d* card::getBoundaryPoints(point2d firstPoint, int threshold, float distance, int& num){
  const int maxsize=200;
  const double pi = 3.14159265;
  const double delta_angle=  5.0  /180.0*pi;//5.0 degreee
  num=0;
  point2d* result=new point2d[maxsize];

  //get out from the table:
  double angle=0;
  while (angle<10.0 &&
	 !table(   point2d(firstPoint, angle, distance), threshold))
    angle+=(pi/2.0);


  point2d center;
  point2d nextPoint=firstPoint;

  do {
    //advance:
    center=nextPoint;

    //store center:
    result[num]=center;
    num++;
    //find next point:
    //move outside if necessary:
    while (!table( point2d(center, angle, distance), threshold))
      angle-=delta_angle;
    //move inside if necessary:
    while (table( point2d(center, angle, distance), threshold))
      angle+=delta_angle;
    nextPoint=point2d(center, angle, distance);
  } while (firstPoint.distance(nextPoint)>0.75*distance);

  return result;
}



void card::Demo(){
  const int frame=5;//frame pixels around the image (to skip)
  int i, j;

  //start from the upper middle point, look for the first card-point:
  j=bmp.getWidth()/2;
  i=frame;
  while (i<bmp.getHeigth()-frame && bmp.map[i][j].r<128)
    i++;
  //store the result in point "begin"
  point2d begin(i,j);

  int boundarypointnum;
  point2d* boundary=getBoundaryPoints(begin, 128, 20, boundarypointnum);

  /////////////////////
  int it=0;
  while (!in_line(boundary[it], boundary[it+2], boundary[it+4]))
    it++;
  line first_line(boundary[it], boundary[it+4]);
  it=it+4;

  while (first_line.distance(boundary[it]) < 20)
    it++;
  while (!in_line(boundary[it], boundary[it+2], boundary[it+4]))
    it++;
  line second_line(boundary[it], boundary[it+4]);

  point2d its=first_line.intersection(second_line);
  /////////////////////


  //mark points begin and end on the image:
  //points with yellow, lines with red:
  bmp.setPen(255,255,0);
  for (int i=0; i<boundarypointnum; i++)
    bmp.dot(boundary[i].X(), boundary[i].Y());

  //////////////////////////
  bmp.setPen(255,0,0);
  bmp.dot(its.X(), its.Y());

  bmp.setPen(0,255,0);
  bmp.line(first_line.p1.X(), first_line.p1.Y(), first_line.p2.X(), first_line.p2.Y());
  bmp.setPen(0,0,255);
  bmp.line(second_line.p1.X(), second_line.p1.Y(), second_line.p2.X(), second_line.p2.Y());
  ///////////////////////////
  bmp.write("copy.pnm");
  //show the image:
  system("xv copy.pnm");

}

