
#include "point2d.h"
#include <stdlib.h>
#include <cmath>
#include <iostream>
using namespace std;

point2d::point2d()
{
  x = 0;
  y = 0;
  next=NULL;
  return;
}

point2d::point2d(double a, double b)
{
  x = a;
  y = b;
  next=NULL;
  return;
}

point2d::point2d(point2d p, double angle, double length)
{
  x = p.x + length * cos(angle);
  y = p.y + length * sin(angle);
  next=NULL;
  return;
}

double point2d::rise(point2d* p1, point2d* p2)
{
    double dx=(p2->x)-(p1->x);
    double dy=(p2->y)-(p1->y);
    if(dx*dx<0.0001)
    	return 0.0;
    else
    	return dy/dx;
}

point2d::point2d(const point2d & a)
{
  x = a.x;
  y = a.y;
  return;
}

bool point2d::operator==(point2d a)
{
  if ((a.x == x) && (a.y == y))
  {
    return true;
  }
  else
  {
    return false;
  }
}

void point2d::operator=(point2d a)
{
  x = a.x;
  y = a.y;
  return;
}

point2d point2d::operator+(point2d a)
{
  point2d b;
  b.x = x + a.x;
  b.y = y + a.y;
  return b;
}

point2d point2d::operator-(point2d a)
{
  point2d b;
  b.x = x - a.x;
  b.y = y - a.y;
  return b;
}

point2d point2d::operator*(double skalar)
{
  point2d a;
  a.x = x * skalar;
  a.y = y * skalar;
  return a;
}

double point2d::distance(point2d a)
{
  return sqrt((a.x - x)*(a.x - x)+(a.y - y)*(a.y - y));
}

double point2d::distance(point2d* p1, point2d* p2)
{
    return sqrt((p1->x-p2->x)*(p1->x-p2->x)+(p1->y-p2->y)*(p1->y-p2->y));
}

point2d operator*(double skalar, point2d p)
{
  point2d a;
  a.x = p.x * skalar;
  a.y = p.y * skalar;
  return a;
}

int point2d::X(){
  return int(x+0.5);
}

int point2d::Y(){
  return int(y+0.5);
}
