// util header file
// written by Stephan Senn, D-ITET
// 22.1.04

#include "point2d.h"
#include "Matrix.h"
#ifndef _util_
#define _util_

class util
{
 public:
    void colorFilter();
    void readImage(char* name); // For reading Images from your harddisk...
    void saveImage(char* name); // For writing Images on your harddisk...
    void blackFilter(); 
    point2d middlepoint; // Calculated after using fetchCorner()-Function...
    point2d* fetchCorner(int step, bool trial);
    void laplaceFilter();
    util(char* name, bool save);
    util(bitmap picture, bool save);
    bool verifyCard(point2d* k1, point2d* k2, point2d* k3, point2d* k4);
    ~util();

 private:
    bitmap bmp; 
    bool si; // for internal use
    struct borderline
	{
	    double rise;
	    double offset;
        };

    borderline lines[4];
    bool checkNormal(Matrix* m);
    point2d* calcISection(borderline b1, borderline b2);
    Matrix* readInMatrix(point2d* head, int length);
    point2d* evalNormalLines(Matrix* top, Matrix* down, Matrix* left, Matrix* right);
    Matrix* divideIntoFirstPart(Matrix* m, int position);
    Matrix* divideIntoSecondPart(Matrix* m, int position);
    void calcLine(Matrix* m, int line);
    point2d point;
    int diffcolor(int i1,int j1,int i2,int j2);
    point2d calcMiddlePoint(Matrix* a, Matrix* b);
    int dividePosition(Matrix* m, point2d p);
    double calcContrast();

};

#endif
